; routine to cycle through the buffers for this job
; written for DATAdesign engine v2.+
; (c)1992 by Joachim Van der Auwera for PROGS
        section text
        include win1_dd_src_engine_aid_mac
        include win1_dd_src_engine_struct_h
        include win1_inc_keys_err
        include win1_inc_keys_ext_thg
*
; routine to cycle through the buffers for this job
; returns zero when last bufferid reached
; if no bufferid passed -> start at beginning
; parameters
p.id    equ     $4      ; buffer id (long word, optional)
p.ret   equ     $c      ; return next buffer id (ulong)
; errors
; itnf  buffer id invalid
cod_CYCB xsub
        regsave a1/a4-a5
        move.l  a1,a5           ; keep params in a safe place
        move.l  p.ret(a5),a1    ; place for return bufferid
        clr.l   (a1)            ; clear it just in case

        move.l  p.id(a5),d0     ; buffer id if passed
        tst.w   p.id-4(a5)      ; is the buffer id given ?
        bne.s   tbuff           ; yes -> ..
        xjsr    frstfid         ; take first fid
        bra.s   emptyst         ; start with this one
tbuff   move.l  d0,a4           ; keep it
        xjsr    testbid         ; and test if it is valid
        bne.s   codend          ; if not -> error

nxtbuff move.l  b_next(a4),d0   ; take next bufferid
        beq.s   nxtfile         ; if there is a next
bufftst move.l  d0,a4
        xjsr    testbid         ; ok for this job ??
        bne.s   nxtbuff         ; no -> try next one

        move.l  a4,(a1)         ; ok this is the next one
        bra.s   codend

nxtfile move.l  b_file(a4),a4   ; get fileid for this buffer
        move.l  f_next(a4),d0   ; next fileid
emptyst beq.s   codend          ; oops, no next found
        move.l  d0,a4           ; this fileid
        move.l  f_buffer(a4),d0 ; start of list of buffers
        bra.s   bufftst         ; and test it
codend
        subend
;
        end
