1000 REMark program to create invoices
1010 REMark this program uses the DATAdesign engine v3 or higher
1020 REMark it also demonstrates how to use DATAdesign as relational database
1030 REMark -----------------------------------------------------------------
1040 REMark written by Joachim Van der Auwera
1050 REMark (c) Jan 1993 by PROGS, PROfessional & Graphical Software
1060 REMark -----------------------------------------------------------------
1070 :
1080 Invoice$       ='                        INVOICE'
1090 ProductHeader$ =' No   Product                           price for one     all'
1100 ProductHeader2$='|---|-----------------------------------------|-------|-------|'
1110 base_curr$='BEF'  : REMark base currency, should be 3 letters
1120 k_esc=27 : k_up=208 : k_down=216 : k_enter=10 : k_f3=240 : k_ff=12 : k_cr=13
1130 dd_err=0
1140 searchkey$=''
1150 prtdevice$='prt'
1160 :
1170 Init_Windows
1180 Init_Files
1190 REPeat Main_Loop
1200    NextLoop =0     : REMark do entire loop
1210    CLS #3
1220    PRINT #3,'Input Search key for name (esc to end) : ';
1230    READstring #3,searchkey$
1240    IF dd_err=k_esc OR searchkey$='' THEN EXIT Main_Loop
1250    FINDstring #customers,c_name,,searchkey$
1260    IF dd_err=-7 THEN 
1270       Notice 'No record found with this name'
1280       NextLoop=1  : REMark re-enter loop
1290       NEXT Main_Loop
1300    ELSE 
1310       REPeat Search_Loop
1320          Show_Customer
1330          CLS #4
1340          PRINT #4,'Search again (yes/no (=esc)) ? ';
1350          query$='no' : READstring #4,query$
1360          CLS #4
1370          IF 'y' INSTR query$ AND dd_err<>k_esc THEN 
1380             FINDstring #customers,c_name,'a',searchkey$
1390             IF dd_err=-7 THEN 
1400                Notice 'No other records found with this name'
1410                NextLoop=1  : REMark re-enter loop
1420                EXIT Search_Loop
1430             ELSE 
1440                NEXT Search_Loop
1450             END IF 
1460          ELSE 
1470             EXIT Search_Loop
1480          END IF 
1490       END REPeat Search_Loop
1500    END IF 
1510    IF NextLoop THEN NEXT Main_Loop
1520    Init_Invoice
1530    Input_Invoice
1540    REPeat InvoiceLoop
1550       CLS #4
1560       PRINT #4,'Is this invoice correct (yes/no (=esc)) ? ';
1570       query$='yes' : READstring #4,query$
1580       CLS #4
1590       IF 'y' INSTR query$ AND dd_err<>k_esc THEN EXIT InvoiceLoop
1600    END REPeat InvoiceLoop
1610    IMPLEMENT #invoices
1620    Print_Invoice
1630    REPeat PrintLoop
1640       CLS #4
1650       PRINT #4,'Print again (yes/no (=esc)) ? ';
1660       query$='yes' : READstring #4,query$
1670       CLS #4
1680       IF 'y' INSTR query$ AND dd_err<>k_esc THEN 
1690          Print_Invoice
1700       ELSE 
1710          EXIT PrintLoop
1720       END IF 
1730    END REPeat PrintLoop
1740 END REPeat Main_Loop
1750 Save_Files
1760 Finish
1770 :
1780 : REMark here come the subroutines
1790 :
1800 DEFine PROCedure Init_Files
1810    : REMark start using all the files we need
1820    USEfile 'customers','win1_data_',1 : REMark customers file, view only
1830    IF dd_err THEN 
1840       Notice 'ERROR on opening customers_ddf' : STOP
1850       Finish
1860    END IF 
1870    customers=bufferID
1880    USEfile 'products','win1_data_',1  : REMark products file, view only
1890    IF dd_err THEN 
1900       Notice 'ERROR on opening products_ddf'
1910       Finish
1920    END IF 
1930    products=bufferID
1940    indexLOAD 'products','win1_data_'  : REMark products index file
1950    IF dd_err THEN 
1960       Notice 'ERROR on opening products_ddi'
1970       Finish
1980    END IF 
1990    FIRSTrec #products  : REMark go to a record, so we can use FISTrec/NEXTrec
2000    USEfile 'invoices','win1_data_'    : REMark invoices file
2010    IF dd_err THEN 
2020       Notice 'ERROR on opening invoices_ddf'
2030       Finish
2040    END IF 
2050    invoices=bufferID
2060    : REMark now initialise the fieldid's
2070    c_initials=1      : REMark text, initials or christian name of customer
2080    c_name=2          : REMark text, name of customer
2090    c_address=3       : REMark text, address of customer
2100    p_product=1       : REMark text, name of product
2110    p_price=2         : REMark float, unitary price
2120    i_number=1        : REMark short
2130    i_customer=2      : REMark long, record ref in customers file
2140    i_amount=3        : REMark short, max 16 lines
2150    i_reference=4     : REMark long, record ref in products file
2160    i_reduction=5     : REMark short, %
2170    i_reason=6        : REMark text, reason for reduction
2180    i_currency=7      : REMark text, 3 chars??
2190    i_rate=8          : REMark float, 1 i_currency = i_rate BEF
2200    i_notes=9         : REMark text, payment or other notes
2210    i_date=10         : REMark text, date of invoice
2220 END DEFine Init_Files
2230 :
2240 DEFine PROCedure Finish
2250    : REMark routine to end this program
2260    REMark remove the buffers
2270    REPeat loop
2280       UNUSEbuffer #CYCLEbuffer
2290       IF dd_err THEN EXIT loop
2300    END REPeat loop
2310    REMark close the channels
2320    FOR i=3 TO 10 : CLOSE #i
2330    STOP
2340 END DEFine Finish
2350 :
2360 DEFine PROCedure Notice (str$)
2370    : REMark report an error and wait for a key to be pressed
2380    CLS #4
2390    PRINT #4,str$;', press a key';
2400    CURSEN #4 : query$=INKEY$(#4,-1) : CURDIS #4
2410    CLS #4
2420 END DEFine Notice
2430 :
2440 DEFine PROCedure Init_Windows
2450    : REMark initialise the windows
2460    white=7:green=4:red=2:black=0
2470    REMark if you don't have the QPTR SuperBASIC interface
2480    REMark then you should remove the OUTLN commands (they are not essential)
2490    compiled=JOB$(-1)<>''
2500    IF NOT compiled THEN OUTLN #0,512,256,0,0
2510    OPEN #3,con_512x12a0x0
2520    IF compiled THEN OUTLN #3,512,256,0,0
2530    BORDER #3,1,green : PAPER#3,white : INK #3,black : CLS#3
2540    OPEN #4,con_512x12a0x11
2550    BORDER #4,1,green : PAPER#4,white : INK #4,black : CLS #4
2560    OPEN #5,con_512x192a0x22
2570    BORDER #5,1,green : PAPER#5,white : INK #5,black : CLS #5
2580    OPEN #6,con_512x32a0x224
2590    BORDER #6,1,green : PAPER#6,white : INK #6,black : CLS #6
2600    OPEN #7,con_94x12a0x213
2610    BORDER #7,1,green : PAPER#7,white : INK #7,black : CLS #7
2620    OPEN #8,con_254x12a94x213
2630    BORDER #8,1,green : PAPER#8,white : INK #8,black : CLS #8
2640    OPEN #9,con_82x12a348x213
2650    BORDER #9,1,green : PAPER#9,white : INK #9,black : CLS #9
2660    OPEN #10,con_82x12a430x213
2670    BORDER #10,1,green : PAPER#10,white : INK #10,black : CLS #10
2680    PRINT #7,'reduction%:'
2690    PRINT #9,'currency:'
2700    PRINT #10,'rate:'
2710 END DEFine Init_Windows
2720 :
2730 DEFine PROCedure sa
2740    : REMark routine to save the file
2750    SAVE_O win1_dd_api_Invoice_bas
2760 END DEFine sa
2770 :
2780 DEFine PROCedure Show_Customer
2790    DEFbuffer customers
2800    CLS #5
2810    PRINT #5,GETline$(c_initials);' ';GETline$(c_name)
2820    FOR i=1 TO NRlines(c_address)
2830       PRINT #5,GETline$(c_address,i)
2840    END FOR i
2850 END DEFine Show_Customer
2860 :
2870 DEFine PROCedure Init_Invoice
2880    : REMark initialise new invoice
2890    DEFbuffer invoices
2900    LASTrec
2910    number=GETshort(i_number)        : REMark get last invoice number
2920    NEWrec                           : REMark new record
2930    SETshort number+1,1              : REMark set new invoice number
2940    SETlong recordID(#customers),i_customer  : REMark set customer reference
2950    datum$=DATE$                     : REMark get date for this invoice
2960    datum$=datum$(1 TO 11)           : REMark  we could also use the recorddate
2970    SETline datum$, i_date           : REMark  but this is safer
2980 END DEFine Init_Invoice
2990 :
3000 DEFine PROCedure Input_Invoice
3010    : REMark edit the contents of the current invoice
3020    : REMark or fill in a new one
3030    CLS #4 : CLS #5
3040    DEFbuffer invoices
3050    PRINT #5,ProductHeader$
3060    PRINT #5,ProductHeader2$
3070    lineno=0
3080    REPeat InvoiceLoop
3090       lineno=lineno+1
3100       IF lineno=16 THEN EXIT InvoiceLoop
3110       CLS#4 : PRINT #4,'type amount, escape to end';
3120       AT #5,lineno+1,1
3130       number=GETshort(i_amount,lineno)
3140       IF number=0 THEN number=1         : REMark in case it didn't exist
3150       query$='1'                        : REMark assume one
3160       EDITstring #5,query$
3170       IF dd_err=k_esc THEN EXIT InvoiceLoop  : REMark esc ??
3180       number=query$
3190       IF number>999 THEN number=999    : REMark test for maximum value
3200       IF number<1 THEN number=1        : REMark test for minimum value
3210       number=INT(number)               : REMark has to be integer
3220       SETshort number,i_amount,lineno  : REMark set new value
3230       AT #5,lineno+1,1 : PRINT #5,number; : CLS #5,4
3240                                        : REMark reprint
3250       Input_Product                    : REMark get the product
3260       AT #5,lineno+1,43 : PRINT #5,base_curr$;
3270       price=GETfloat(#products,p_price): REMark price for this product
3280       query$=price
3290       PRINT #5,' ';FILL$(' ',7-LEN(query$));query$;
3300       query$=price*number
3310       PRINT #5,' ';FILL$(' ',7-LEN(query$));query$;
3320    END REPeat InvoiceLoop
3330    REMark now edit reduction & reason
3340    CLS #4 : AT #7,0,11
3350    PRINT #4,'edit percentage reduction or press esc';
3360    number= GETshort(i_reduction)       : REMark get current value
3370    query$=number                       : REMark convert to string
3380    EDITstring #7,query$                : REMark edit it
3390    number=query$ : number=INT(number)  : REMark convert back to number
3400    IF number >60 THEN number=60        : REMark make in range
3410    IF number<0 THEN number=0           : REMark (we don't accept more than 60%)
3420    AT #7,0,11 : PRINT #7,number : CLS #7,4 : REMark print actual value
3430    IF dd_err<>k_esc AND number<>0 THEN 
3440       SETshort number,i_reduction      : REMark set the reduction
3450       CLS #4 : CLS #8
3460       PRINT #4,'give the reason for that reduction';
3470       query$=GETline$(i_reason)
3480       EDITstring #8,query$             : REMark edit the reason
3490       SETline query$,i_reason
3500    ELSE 
3510       SETshort 0,i_reduction
3520    END IF 
3530    REMark now edit currency & rate
3540    CLS #4 : AT #9,0,9 : AT #10,0,5
3550    PRINT #4,'edit currency if total also in another currency, or press esc';
3560    query$=GETline$(i_currency)
3570    EDITstring #9,query$
3580    SETline query$,i_currency
3590    IF query$<>'' AND dd_err<>k_esc THEN 
3600       rate=GETfloat(i_rate)
3610       query$=rate
3620       EDITstring #10,query$
3630       rate=query$
3640       SETfloat rate,i_rate
3650    END IF 
3660    REMark now edit notes
3670    CLS #4
3680    PRINT #4,'edit notes about payment etc.';
3690    query$=GETline$(i_notes,1)
3700    IF query$='' THEN query$='paid by VISA'
3710    AT #6,0,0
3720    EDITstring #6,query$
3730    IF dd_err<>k_esc THEN SETline query$,i_notes,1
3740    IF query$<>'' AND dd_err<>k_esc THEN 
3750       query$=GETline$(i_notes,2)
3760       AT #6,1,0
3770       EDITstring #6,query$
3780       IF dd_err<>k_esc THEN SETline query$,i_notes,2
3790    END IF 
3800    IF query$<>'' AND dd_err<>k_esc THEN 
3810       query$=GETline$(i_notes,3)
3820       AT #6,2,0
3830       EDITstring #6,query$
3840       IF dd_err<>k_esc THEN SETline query$,i_notes,3
3850    END IF 
3860 END DEFine Input_Invoice
3870 :
3880 DEFine PROCedure Input_Product
3890    : REMark routine to specify and fill in the product
3900    CLS#4
3910    PRINT #4,'select product, use Up, Down, Enter, first char, f3 to rebuild index';
3920    AT #5,lineno+1,5 : CURSEN #5
3930    REPeat ProductLoop
3940       AT #5,lineno+1,5
3950       query$ = GETline$(#products,p_product)
3960       PRINT #5,query$; : CLS #5,4
3970       key=CODE(INKEY$(#5,-1))
3980       IF key>=CODE('A') AND key<=CODE('z') THEN 
3990          GETrec #products,indexFIND (#products,CHR$(key))
4000       END IF 
4010       IF key=k_enter THEN EXIT ProductLoop
4020       IF key=k_up THEN PREVrec #products
4030       IF key=k_down THEN NEXTrec #products
4040       IF key=k_f3 THEN indexUPDATE #products
4050    END REPeat ProductLoop
4060    SETlong #invoices,recordID(#products),i_reference,lineno
4070    CURDIS #5 : CLS #4
4080 END DEFine Input_Product
4090 :
4100 DEFine PROCedure Print_Invoice
4110    : REMark print current invoice to prt
4120    OPEN #11,prtdevice$
4130    Margin 45
4140    PRINT #11,FILL$(CHR$(k_enter),8)    : REMark skip some lines
4150    DEFbuffer customers
4160    GETrec GETlong(#invoices,i_customer): REMark get cross-reference to customers
4170    PRINT #11,GETline$(c_initials)!GETline$(c_name)
4180    FOR i=1 TO NRlines(c_address)
4190       PRINT #11,GETline$(c_address,i)
4200    END FOR i
4210    Margin 8
4220    DEFbuffer invoices
4230    PRINT #11,\\\Invoice$!!GETshort(i_number);',      ';GETline$(i_date)
4240    PRINT #11,\\\ProductHeader2$\ProductHeader$\ProductHeader2$\\
4250    total=0
4260    FOR lineno=1 TO fieldLEN(i_amount)
4270       number=GETshort(i_amount,lineno) : query$=number
4280       PRINT #11,' ';query$;FILL$(' ',5-LEN(query$));
4290       GETrec #products,GETlong(i_reference,lineno)
4300       query$=GETline$(#products,p_product)
4310       PRINT #11,query$;FILL$(' ',36-LEN(query$))!base_curr$;
4320       price=GETfloat(#products,p_price): REMark price for this product
4330       query$=price : PRINT #11,' ';FILL$(' ',7-LEN(query$));query$;
4340       price=price*number
4350       query$=price : PRINT #11,' ';FILL$(' ',7-LEN(query$));query$
4360       total=total+price
4370    END FOR lineno
4380    REMark now print total
4390    Margin 43+8 : PRINT #11,'            -------'
4400    query$=total : PRINT #11,'BEF ';FILL$(' ',15-LEN(query$));query$;
4410    REMark now print price reduction
4420    number = GETshort(i_reduction)
4430    IF number THEN 
4440       Margin 8
4450       query$=number
4460       PRINT #11,\'reduction'!number!'% :'
4470       query$=GETline$(i_reason)
4480       PRINT #11,query$;FILL$(' ',42-LEN(query$))!base_curr$;'        -';
4490       query$=total*number/100 : PRINT #11,FILL$(' ',7-LEN(query$));query$;
4500       total=total*(100-number)/100
4510       REMark now re-print total
4520       Margin 43+8 : PRINT #11,\'            -------'
4530       query$=total : PRINT #11,'BEF ';FILL$(' ',15-LEN(query$));query$;
4540    END IF 
4550    REMark now print currency data
4560    query$=GETline$(i_currency)
4570    IF query$<>'' THEN 
4580       Margin 8
4590       PRINT #11,\'exchange rate : BEF'!GETfloat(i_rate)!'='!query$!1
4600       PRINT #11,'to pay        :'!query$!total/GETfloat(i_rate);
4610    END IF 
4620    REMark end of data
4630    Margin 8
4640    PRINT #11,\\ProductHeader2$
4650    REMark now print notes
4660    FOR i=1 TO NRlines(i_notes)
4670       PRINT #11,GETline$(i_notes,i)
4680    END FOR i
4690    PRINT #11,ProductHeader2$
4700    REMark now print some obligatory garbage
4710    PRINT #11,\'Goederen blijven in het bezit van PROGS tot ze volledig betaald zijn'
4720    PRINT #11,'Goods remain the property of PROGS until paid for in full'
4730    PRINT #11,\'Kleine onderneming onderworpen aan vrijstelling van belasting.'
4740    PRINT #11,'BTW niet van toepassing'
4750    PRINT #11,'Small company subjected to freedom of taxes. No VAT applicable.'
4760    Margin 0
4770    BPUT #11,k_ff           : REMark eject page
4780    CLOSE #11
4790 END DEFine Print_Invoice
4800 :
4810 DEFine PROCedure Margin (marg)
4820    PRINT #11,CHR$(k_cr);CHR$(k_esc);'&a';marg;'L';
4830 END DEFine Margin
4840 :
4850 DEFine PROCedure Save_Files_
4860    REPeat Save_Loop
4870       SAVEfile #invoices,,,1
4880       IF dd_err=0 THEN 
4890          EXIT Save_Loop
4900       ELSE 
4910          Notice 'There has been an error on saving'
4920       END IF 
4930    END REPeat Save_Loop
4940 END DEFine Save_Files_
4950 :
4960 DEFine PROCedure Save_Files
4970    Save_Files_
4980    CLS #4
4990    PRINT #4,'Backup (yes/no (=esc)) ? ';
5000    query$='yes' : READstring #4,query$
5010    CLS #4
5020    IF 'y' INSTR query$ AND dd_err<>k_esc THEN Save_Files_
5030 END DEFine Save_Files
