; SIRS, GIRS : set, get inter record space
; written for DATAdesign engine v2.+
; (c)1992 by Joachim Van der Auwera for PROGS
        section text
        include win1_dd_src_engine_aid_mac
        include win1_dd_src_engine_struct_h
        include win1_inc_keys_err
*
; set inter record space (max 255)
; parameters
p.id    equ     $4      ; buffer id (long word, optional)
p.key   equ     $8      ; new value for inter record space
; errors
; itnf  buffer id invalid
; orng  hey, maximum 255, that's already a lot
cod_SIRS xsub
        regsave d1/a0/a4/a5
        move.l  a1,a5           ; keep params in a safe place

        move.l  p.id(a5),d0     ; buffer id if passed
        tst.w   p.id-4(a5)      ; is the buffer id given ?
        bne.s   sibuff          ; yes -> ..
        xjsr    getbuff         ; get default buffer
sibuff  move.l  d0,a4           ; keep it
        xjsr    testbid         ; and test if it is valid
        bne.s   siend           ; if not -> error

        move.l  b_file(a4),a4   ; we only need fileid

        moveq   #err.orng,d0    ; assume value too high
        move.w  p.key+2(a5),d1  ; new value
        bmi.s   siend           ; can't be nagative
        cmpi.w  #256,d1         ; test range
        bpl.s   siend           ; oops, forget it

        move.w  d1,f_irsp(a4)   ; fill in new value
        moveq   #0,d0           ; no error

        ; put it on disk if disk based
        tst.b   f_file(a4)      ; is it ?
        beq.s   siend
        mutex
        move.l  f_chid(a4),a0   ; channel id
        moveq   #24,d1          ; filepos
        xjsr    iof_posa
        bne.s   ahum
        move.b  f_irsp(a4),d1
        xjsr    iob_sbyt
        bne.s   ahum
        move.b  f_irsp+1(a4),d1
        xjsr    iob_sbyt
ahum    endmutex
        move.l  d0,d1
        xjsr    iof_flsh
        move.l  d1,d0
siend
        subend
*
; get inter record space
; parameters
;p.id    equ     $4      ; buffer id (long word, optional)
p.ret   equ     $c      ; return record id (uword)
; errors
; itnf  buffer id invalid
cod_GIRS xsub
        regsave d1/a1/a4/a5
        move.l  a1,a5           ; keep params in a safe place

        move.l  p.id(a5),d0     ; buffer id if passed
        tst.w   p.id-4(a5)      ; is the buffer id given ?
        bne.s   gibuff          ; yes -> ..
        xjsr    getbuff         ; get default buffer
gibuff  move.l  d0,a4           ; keep it
        xjsr    testbid         ; and test if it is valid
        bne.s   giend           ; if not -> error

        move.l  b_file(a4),a4   ; we only need fileid

        move.l  p.ret(a5),a1    ; place to put return parameter
        move.w  f_irsp(a4),(a1) ; fill in return value
giend
        subend
;
        end
